// deno-fmt-ignore-file
// deno-lint-ignore-file

// Copyright Joyent and Node contributors. All rights reserved. MIT license.
// Taken from Node 18.12.1
// This file is automatically generated by `tests/node_compat/runner/setup.ts`. Do not modify this file manually.

// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

'use strict';

// Ignore on Windows.
if (process.platform === 'win32') {
  process.exit(0);
}

const {
  mustCall,
  mustNotCall,
  platformTimeout,
} = require('../common');
const fork = require('child_process').fork;
const debug = require('util').debuglog('test');

if (process.argv[2] === 'child') {
  debug('child -> call disconnect');
  process.disconnect();

  setTimeout(() => {
    debug('child -> will this keep it alive?');
    process.on('message', mustNotCall());
  }, platformTimeout(400));

} else {
  const child = fork(__filename, ['child']);

  child.on('disconnect', mustCall(() => {
    debug('parent -> disconnect');
  }));

  child.once('exit', mustCall(() => {
    debug('parent -> exit');
  }));
}
