// deno-fmt-ignore-file
// deno-lint-ignore-file

// Copyright Joyent and Node contributors. All rights reserved. MIT license.
// Taken from Node 20.11.1
// This file is automatically generated by `tests/node_compat/runner/setup.ts`. Do not modify this file manually.

// Flags: --expose-internals
'use strict';

require('../common');
const {
  strictEqual,
  throws,
} = require('assert');
const { AbortError } = require('internal/errors');

{
  const err = new AbortError();
  strictEqual(err.message, 'The operation was aborted');
  strictEqual(err.cause, undefined);
}

{
  const cause = new Error('boom');
  const err = new AbortError('bang', { cause });
  strictEqual(err.message, 'bang');
  strictEqual(err.cause, cause);
}

{
  throws(() => new AbortError('', false), {
    code: 'ERR_INVALID_ARG_TYPE'
  });
  throws(() => new AbortError('', ''), {
    code: 'ERR_INVALID_ARG_TYPE'
  });
}
