// deno-fmt-ignore-file
// deno-lint-ignore-file

// Copyright Joyent and Node contributors. All rights reserved. MIT license.
// Taken from Node 20.11.1
// This file is automatically generated by `tests/node_compat/runner/setup.ts`. Do not modify this file manually.

'use strict';
const common = require('../common');
const { finished } = require('stream');

const http = require('http');
const assert = require('assert');

const server = http.createServer(function(req, res) {
  let closed = false;
  res
    .on('close', common.mustCall(() => {
      closed = true;
      finished(res, common.mustCall(() => {
        server.close();
      }));
    }))
    .end();
  finished(res, common.mustCall(() => {
    assert.strictEqual(closed, true);
  }));

}).listen(0, function() {
  http
    .request({
      port: this.address().port,
      method: 'GET'
    })
    .on('response', function(res) {
      res.resume();
    })
    .end();
});
