// deno-fmt-ignore-file
// deno-lint-ignore-file

// Copyright Joyent and Node contributors. All rights reserved. MIT license.
// Taken from Node 20.11.1
// This file is automatically generated by `tests/node_compat/runner/setup.ts`. Do not modify this file manually.

'use strict';
const common = require('../common');

const assert = require('assert');
const net = require('net');

const server = net.createServer();

server.on('connection', (socket) => {
  let endEmitted = false;

  socket.once('readable', () => {
    setTimeout(() => {
      socket.read();
    }, common.platformTimeout(100));
  });
  socket.on('end', () => {
    endEmitted = true;
  });
  socket.on('close', () => {
    assert(endEmitted);
    server.close();
  });
  socket.end('foo');
});

server.listen(common.mustCall(() => {
  const socket = net.createConnection(server.address().port, () => {
    socket.end('foo');
  });
}));
