// deno-fmt-ignore-file
// deno-lint-ignore-file

// Copyright Joyent and Node contributors. All rights reserved. MIT license.
// Taken from Node 20.11.1
// This file is automatically generated by `tests/node_compat/runner/setup.ts`. Do not modify this file manually.

'use strict';

const common = require('../common');

const assert = require('node:assert');
const readline = require('node:readline');
const { Readable } = require('node:stream');


const input = Readable.from((function*() {
  yield 'a\nb';
  yield '\r\n';
})());
const rl = readline.createInterface({ input, crlfDelay: Infinity });
let carriageReturns = 0;

rl.on('line', (line) => {
  if (line.includes('\r')) carriageReturns++;
});

rl.on('close', common.mustCall(() => {
  assert.strictEqual(carriageReturns, 0);
}));
