// deno-fmt-ignore-file
// deno-lint-ignore-file

// Copyright Joyent and Node contributors. All rights reserved. MIT license.
// Taken from Node 20.11.1
// This file is automatically generated by `tests/node_compat/runner/setup.ts`. Do not modify this file manually.

'use strict';

const common = require('../common');
const { Duplex } = require('stream');
const assert = require('assert');

// basic
{
  // Find it on Duplex.prototype
  assert(Object.hasOwn(Duplex.prototype, 'writableFinished'));
}

// event
{
  const duplex = new Duplex();

  duplex._write = (chunk, encoding, cb) => {
    // The state finished should start in false.
    assert.strictEqual(duplex.writableFinished, false);
    cb();
  };

  duplex.on('finish', common.mustCall(() => {
    assert.strictEqual(duplex.writableFinished, true);
  }));

  duplex.end('testing finished state', common.mustCall(() => {
    assert.strictEqual(duplex.writableFinished, true);
  }));
}
