// deno-fmt-ignore-file
// deno-lint-ignore-file

// Copyright Joyent and Node contributors. All rights reserved. MIT license.
// Taken from Node 20.11.1
// This file is automatically generated by `tests/node_compat/runner/setup.ts`. Do not modify this file manually.

'use strict';
const common = require('../common');
const assert = require('assert');
const { Readable, Writable, Transform } = require('stream');

{
  const stream = new Readable({
    objectMode: true,
    read: common.mustCall(() => {
      stream.push(undefined);
      stream.push(null);
    })
  });

  stream.on('data', common.mustCall((chunk) => {
    assert.strictEqual(chunk, undefined);
  }));
}

{
  const stream = new Writable({
    objectMode: true,
    write: common.mustCall((chunk) => {
      assert.strictEqual(chunk, undefined);
    })
  });

  stream.write(undefined);
}

{
  const stream = new Transform({
    objectMode: true,
    transform: common.mustCall((chunk) => {
      stream.push(chunk);
    })
  });

  stream.on('data', common.mustCall((chunk) => {
    assert.strictEqual(chunk, undefined);
  }));

  stream.write(undefined);
}
